* 2012-07-30 0.9.1 released

2012-07-28 str4d
 * Console: theme fixes

2012-07-26 kytv
* Update geoip.txt based on Maxmind GeoLite Country database from 2012-07-04
* Finnish, French, German, Spanish and Swedish translation updates from TX

2012-07-26 sponge
* BOB Fix static references to Log

2012-07-24 sponge
 * BOB reset spin flag to enable restart from zap command

2012-07-24 str4d
 * Summary bar: disable fallback iframe in summary.jsi (so when JS is disabled
   the summary bar will not refresh at all)
 * Home page:
   - Replaced 16x16 icons with 32x32 ones
   - Updated icon for git.repo.i2p
   - Moved RestartStatus back above LocalDestinations

2012-07-24 zzz
 * LookaheadInputStream: Fix bug causing gunzip fails, esp. on Android
 * Router: Don't create router.ping file on Android
 * SSLEepGet: Fix on Android (ticket #668)

2012-07-21 zzz
 * i2psnark: Remove dark theme
 * Reseed: Add new cert for cowpuncher
 * SSU: Remove exception creation (ticket #665)

2012-07-21 str4d
 * Home page: unlinked the iframed pages for i2psnark and susimail (the pages
   /webmail and /torrents still exist, but the console links to the apps
   directly instead for now)

2012-07-19 str4d
 * Home page: replaced itoopie with an eepsite icon (c/o dr|z3d) for eepsites
   with no icon of their own.
 * i2psnark:
   - New light theme (c/o dr|z3d) which integrates with console light theme
   - Moved table heading text into tooltips to reduce visual clutter

2012-07-18 str4d
 * Home page: Added id3nt.i2p and git.repo.i2p

2012-07-18 zzz
 * Home page: Add colombo-bt.i2p, remove keys.i2p
 * i2psnark: Clear rate stats when restarting torrent

2012-07-16 str4d
 * console: work towards better integration
   - Wrapped the bundled apps in iFrames (with a link in the page header to
     open the app in a new tab):
     - i2ptunnel
     - i2psnark
     - susimail
     - susidns
   - Theme improvements
     - Added theme support to susimail and susidns
       - "susimail.theme=foo" in susimail.config
       - "theme=foo" on susidns config page
     - Extensive work on dark console theme (dr|z3d)
       - Improved integration of i2ptunnel in iframe
       - General improvements
     - New dark themes for i2psnark, susimail and susidns which integrate well
       with dark console theme (dr|z3d)
     - Tweaks to other themes (console and i2psnark) to work with the various
       structural changes (dr|z3d)
     - Added per-theme favicons
     - Updated IE shim to fix some issues
   - Summary bar improvements
     - Updated every console page to use Ajax for the summary bar
       - Falls back to iFrame if JS disabled
       - Ajax refresh time is adjustable
     - The summary bar is now customizable; sections can be added, removed and
       reordered as desired
     - Added/updated tooltips
     - Added a new summary bar section to show news headings when the main news
       display is hidden
   - Changes to structure of /home to bring it in line with rest of console
 * i2psnark
   - Reworked the torrent info/file manager page to improve the layout

2012-07-15 zzz
 * XORComparator: Reduce object churn (Ticket #658)

2012-07-12 kytv
* Translations from Transifex:
  - Add new Greek translation
  - Dutch translation update

2012-07-01 zzz
 * i2psnark:
   - Don't send a keepalive to a peer we are going to disconnect
   - Disconnect peer when idle a long time
   - PeerCheckerTask cleanup
   - Static ref cleanup
   - Don't show a downloaded torrent file as "seeding"
   - Better torrent file download icon

2012-06-29 zzz
 * HTTP Proxy: Change the error code for unknown host from 404 to 500
 * SimpleTimer: Fix logging
 * Streaming:
   - Allow at least 3 packets and up to half the window to be active resends
     instead of just 1, to reduce stall time after a packet drop
   - Increase fast retransmit threshold back to 3 to reduce retransmissions
   - Don't fast retransmit if we recently retransmitted it already
   - Allow double the window as long as gaps are less than the window
   - Don't set the MSS in a resent packet (saves 2 bytes)
   - Remove redundant calls to updateAcks()
   - Update activity timer when resending a packet
   - Reset unackedPacketsReceived counter at all places where acks are sent
     so it isn't wrong
   - Fix some places where the activeResends count could become wrong
   - Prevent storm of CLOSE packets
   - Never resend the whole packet in ackImmediately(), just send an ack
   - Cancel flusher timer in MessageOutputStream when closed
   - Move some createRateStats to ConnectionManager to reduce repeated calls
   - Cleanups, javadocs, logging, volatile, finals
 * Update: Increase eepget timeouts

2012-06-24 zzz
 * ElGamalAESEngine: Fix bad size estimate when tags are included,
                     resulting in trailing zeros after the padding
                     in the unencrypted data
 * i2psnark: Don't create a new PeerCoordinator after restart, as the
             TrackerClient holds on to the old one and that causes it
             to not get peers. Possibly fixes ticket #563.
 * I2PTunnel: Fix NPE on shared client creation, thx kytv
 * Transport: Add Ethiopia to hidden mode list

2012-06-21 zzz
 * I2CP: Make separate message ID counters per-destination, use atomic,
         increase max (could have caused "local loopback" problems)
 * IRC Client: Don't flush output unless out of input, so the
               streaming messages don't get split up unnecessarily
 * OCMOSJ, ElG, Streaming: log tweaks
 * TunnelInfo: Change msg counter from long to int
 * TunnelPeerSelectors: Minor refactoring to store context
 * TunnelPool: Fix bug where a tunnel was marked as reused when it wasn't
 * TunnelPoolManager: Use one ClientPeerSelector for all pools

2012-06-20 zzz
 * I2PSession:
   - Greatly simplify the VerifyUsage timers
   - Constructor cleanup

2012-06-19 zzz
 * i2psnark:
   - Hide buttons while stopping all
 * Socks: Pass remote port through
 * Streaming:
   - Listen only on local port if set
   - Listen only for streaming protocol if configured (new option)
   - Javadocs re: ports

2012-06-18 zzz
 * i2psnark:
   - Improve torrent shutdown handling to maximize chance of
     announces getting to tracker
   - Thread task to open tunnel and improve UI feedback while open is pending
   - Clean up delete-torrent messages
   - Remove redundant shutdown hook
   - Avoid NPE in PEX message handling
   - Log tweaks

2012-06-15 zzz
 * I2PSocketEepGet: Use specified port
 * I2PTunnel:
   - Don't strip port from an I2P URL
   - More client options cleanups
   - Options changes now propagate to running
     socket managers and sessions, and through to the router
   - Better parsing of jump server URLs
 * NetDB: Only publish stats every so often, to improve
   anonymity while preserving the ability to monitor
   the network (effective next release)
 * SocketManager:
   - Simplify factory, use 4-arg constructor,
     make fields final, deprecate 0-arg constructor
   - Improve how options are updated
   - Javadocs

2012-06-13 zzz
 * I2PSocketEepGet: Set port to 80
 * I2PTunnel:
   - Pass port through HTTP client proxy
   - HTTP server proxy sets host header to
     the value of "spoofedhost.xx" option for port xx
   - Set client options more efficiently
 * i2psnark: Possible fix for piece-after-choke
 * Streaming:
   - Channel cleanups and comments
   - New I2PSocketAddress

2012-06-11 zzz
 * i2psnark:
   - Display torrent file downloads in torrent area
   - Sort magnets and downloads first
   - Fix sorting problem when torrent dir is a symlink
   - Reduce max file idle time
   - Reduce TrackerClient threads
   - Reduce delay between peer adds for faster startup
   - Thread the announces and reduce timeout when stopping
 * NativeBigInteger: Workaround for Raspberry Pi to load the correct lib
 * Router: Don't let shutdown tasks hang the shutdown (tickets #564, #566)

2012-06-08 zzz
 * i2psnark:
   - Move private tracker config from create box to torrent config
   - Refactor private and open tracker configuration
   - Add private indication on details page
 * netdb.jsp: Don't show our info on summary page

2012-06-04 zzz
 * i2psnark: Take tracker out of opentracker list when removed

2012-06-03 kytv
* Translation updates:
  - Add Hungarian language from Transifex (thanks AdminLMH!)
  - Italian language updates from Transifex (thanks ColumboBT)

2012-06-02 zzz
 * i2psnark: Improve opentracker configuration
 * Job Queue: Add failsafe check

2012-06-01 zzz
 * Console: Tab the netdb and profile pages
 * i2psnark: Fix partially-complete torrent not announcing
 * NetDB: Reduce flood redundancy from 8x to 6x

2012-05-31 zzz
 * i2psnark:
   - Add per-hour conn limit
   - Blacklist peer after two bad handshakes
   - Reduce connect timeout
   - Close connection immediately if bad protocol
   - Stop adding peers when we hit the limit
   - Lower limit for outbound connections so we give
     new peers a better chance in large swarms

2012-05-30 zzz
 * Graphs: Reduce log EOF error to warn
 * i2psnark:
   - Increase max upload (ticket #645)
   - Increase per-minute conn limit from 6 to 8
   - Improve rarest-first behavior
   - Handle URI encoding, UTF-8, and multiple trackers in magnet links
 * Timestamper:
   - Move from core to router, leave stub in core
     so it doesn't break compatibility. This removes a
     thread in app context and prevents any app context from
     running NTP; external clients must use the time
     received from the router.
   - Increase query interval

2012-05-28 kytv
 * i2prouter: Add support so that 'i2prouter install' will work in ArchLinux
 * jbigi/jcpuid scripts: Improve support for ArchLinux

2012-05-25 kytv
 * German, Italian, Spanish, and Swedish translation updates from Transifex

2012-05-23 zzz
 * i2psnark:
   - Fixes when complete except for skipped files
     (ticket #447) status in UI, don't connect outbound,
     disconnect seeds when done
   - Custom tracker map AIOOBE fix
   - More classes pkg private
 * jobs.jsp: Add more queue diagnostics

2012-05-22 zzz
 * i2psnark:
   - Refactor tracker map
   - Prevent torrent shutdown when changing file priority to skip
   - Fix deadlock when changing file priorities
 * RoutingKeyModifier: Update after large clock shift

2012-05-20 zzz
 * Console: Add full file path to thread dump message
 * i2psnark:
   - Create sparse files at torrent creation and delay
     "ballooning" until first write (ticket #641, #447)
   - Redo clear messages button
   - Concurrent message queue
 * Profiles: reduce same-country bonus
 * RoutingKeyModifier: Several changes to ensure the routing key
                       is correctly changed just after midnight.

2012-05-19 zzz
 * i2psnark:
   - Store received chunks in temp files
   - Don't allocate from heap for unneeded chunks
   - Remove peer count restriction for torrents with large pieces
   - Use priorities and rarest calculations to sort partials
   - Preserve p parameter in clear messages link

2012-05-13 zzz
 * Console: Add X-Frame-Options to headers,
   disable with routerconsole.disableXFrame=true

* 2012-05-02 0.9 released

2012-04-26 kytv
 * German, Spanish, and Swedish Translation updates
   from Transifex

2012-04-20 zzz
 * Remove search box
 * Fix i2psnark dir when started from Windows no-wrapper
   (ticket #627)

2012-04-14 kytv
 * Update wrapper to v3.5.14
 * Update geoip.txt from Maxmind's April 2012 database

2012-04-12 kytv
 * German, Spanish, and Swedish translation updates from Transifex

2012-04-12 zzz
  * Console:
    - Try again to fix console on Windows w/o IPv6
      by starting connectors individually
    - Fix whitespace issues on several pages
    - Prevent rare early NPE
    - Non-default theme cleanups
    - Theme and translate home page logo

2012-03-28 zzz
  * RouterInfo: Fix fatal NPE in last checkin

2012-03-27 zzz
  * FloodfillVerify:
    - Fix verifies stuck on one peer by blamimg the verify peer on failure
    - Follow DSRM in response to RI verifies
    - Increase floodfill verify timeout
  * Home page: Delay router down message until two consecutive fails
  * RouterInfo: Add method to validate sig during read-in for speed

2012-03-27 sponge
  * A hopeful fix to allow SHOUTcast/icecast to work over the http proxy.
  * A little more code clean up

2012-03-26 zzz
  * Code cleanups:
    - Remove unused imports
    - Remove unused local variables
    - Remove unused private fields
    - Remove unnecessary casts
  * Console:
    - Try again to fix console on Windows w/o IPv6 (ticket #621)
    - Move oldconsole rendering from Router to OldConsoleHelper

2012-03-24 zzz
  * GarlicConfig: Remove more unused methods
  * i2psnark:
    - Fix dup torrent msg with magnets (tickets #433 and #504)
    - Fix state when storage dies during transition out of magnet mode
    - Fix NPE in magnet mode
    - Error logging improvements
    - Support add-torrent with infohash alone
    - CSS tweaks

2012-03-22 zzz
  * Home page: CSS tweaks
  * Reseeder: Get rid of static instance, root in netDB,
              don't use system properties for status
  * RetransmissionTimer: Instantiate per-destination
  * Router: When removing a config setting, remove from context also
  * SimpleScheduler, SimpleTimer, SimpleTimer2: Replace static instances
    with I2PAppContext-rooted references

2012-03-20 zzz
  * i2psnark: Message area tweaks and clear link
  * NetDB:
    - Don't reread RI if netdb date is recent
    - Prevent LS/RI overwrites
    - Disallow hash mismatches in RI files
    - Reseed won't fetch our own RI
    - Reseed won't overwrite recent RIs
  * Router: Make runRouter() public

2012-03-19 sponge
  * Plugins: Less confusing message, fix CNFE by catch and ignore on delete.
             Order and reverse order plugin names for start/stop all cases.

2012-03-18 zzz
  * Jetty: Fix check alias override

2012-03-17 zzz
  * BuildHandler: Implement restart and shutdown to stop the thread
  * Jetty: Don't extract wars
  * FileUtil: Better logging of weird unpack200 errors
  * I2PTunnel: Make CLI-only methods private, and static where possible
  * Streaming: Scheduler cleanup

2012-03-16 zzz
  * FragmentHandler: Zero-copy read of unfragmented messages
                     for speed and to reduce object churn
  * Home page: Tag tooltip; CSS tweaks; news tweak
  * HTTP Proxy: Jump and addresshelper page tweaks
  * Jetty: Add I2P mime types to default eepsite config
  * OCMOSJ: Refactor cache to its own class, make non-static
  * TransportManager: Fix fatal exception on soft restart caused by DHSKB refactoring
  * TrustedUpdate: Preserve default key names even when keys are set
                   in advanced config

2012-03-15 sponge
  * Plugins:
    - String.isEmpty() [ java 6 ] -> (String.length() == 0) [ java 5 ]
    - for a file: URL, use "Attempting to copy plugin from" message
    - s/{0}// on non-translated string
    - grammar: "File copy failed {0}" -> "Failed to copy file from {0}"
    - use the context provided to get startup time
    - getCanonicalPath() -> getAbsolutePath()
    - install != update. Don't change the user's settings, and don't restart
      it on an update if "dont-start-at-install". This gives the same
      functionality as before.

2012-03-14 zzz
  * Blockfile, i2psnark: Remove static logs
  * DHSessionKeyBuilder:
    - Move from core to router/transport
    - Make non-static, instantiate in TransportManager
    - Generate keypair in constructor and make final
      to move more processing to the precalc thread
      and eliminate races
    - Synchronize getSessionKey() to eliminate races
    - Comment out unused methods
  * Jetty:
    - Set default cache-control for webapps and eepsite
    - Disable dir listing for console webapps
  * UDPTransport:
    - Make key builder final in InboundEstablishState to
      eliminate rare NPE (ticket #406)
    - Remove unused static instance
  * YKGenerator: Make non-static, instantiate in ElGamalEngine

2012-03-13 sponge
  * Add sponge.i2p :-D bump version.

2012-03-13 sponge
  * Plugins:
    - Fix a bug in the updater. It was not comparing the correct name.
    - Plugin updates can now be deferred if router-restart-required is set.
      The update happens at the next router restart.

2012-03-13 sponge
  * Plugins:
     - Handle 'file://' URLs for installation and updates (ticket #429).
       You must specify the entire path, e.g.
       file:///home/someone/magicplugin.xpi2p
       - This works for updates too!
       - Only tested on Linux, needs to be tested on Windows.

2012-03-12 zzz
  * Console:
    - Better IPv6 test, hopefully will work on Windows
    - Hide home page flags once language is selected
    - Home page shrinkage and other CSS tweaks

2012-03-11 sponge
  * Slackware package script updates

2012-03-11 zzz
  * Build:
    - Include old commons logging classes in commons-logging.jar
    - Preserve manifests in Jetty/Tomcat jars
  * Jetty Logger: Promote warns to errors when a Throwable is the second arg

2012-03-11 sponge
  * fix broken comment in jetty.xml

2012-03-10 zzz
  * Build: Add new jetty jars to router.jar classpath so it works
    on very old installs with individual jars specified in the
    wrapper.config classpath
  * configloggging: Fix clearing log overrides
  * Console: Test if IPv6 addresses will work before instantiating
             connectors, so Jetty will still start without them
  * HTTP Proxy: Fix generation of jump links (ticket #616),
                broken by refactoring in -1
  * Jetty Logger: Put a note in wrapper log saying where the logs went

2012-03-09 zzz
  * Update default eepsite base context to use DefaultServlet
    instead of ResourceHandler, to provide resume, directory
    indexes, caching, etc.
  * Simplify default eepsite base and CGI contexts to use a Context
    instead of a ContextHolder, ServletHandler, and ServletHolder

2012-03-08 zzz
  * GarlicConfig: Remove unused reply block methods
  * SessionKeyManager:
    - Don't use unacked tagsets after consecutive ack failures
      and revert to full ElGamal if necessary (ticket #574)
    - Synchronize creation of new sessions to prevent dups
    - Don't remove an unacked session until it's really out of tags
    - Failsafe removal of old unacked tagsets
    - Cleanups, final, comments, log tweaks, debug.jsp tweaks, synchronization tweaks

2012-03-06 kytv
 * German and Spanish translation updates from Transifex

2012-03-06 zzz
  * i2psnark: Fix NPE on magnet link addition
  * Jetty logger: Fix stack trace logging
  * viewstat.jsp: Properly close the ImageOutputStream to fix
    NPEs in the finalizer, probably was the root cause of
    what we blamed on Jetty
  * Webapp class loader: Fix dup classes in classpath
    caused by last checkin (symptom: i2psnark in wrong directory)

2012-03-05 zzz
  * Build: Make windows and non-windows installers for release
  * configclients: Tweaks
  * Graphs: Add time interval to legend
  * NetDB: Increase min ff to 250
  * Plugins: Fix setting webapp classpath on Jetty 6
  * UDP: Log tweaks
  * viewstat.jsp: Set Connection: Close to work around Jetty bug
    http://jira.codehaus.org/browse/JETTY-1346

2012-03-04 zzz
  * Jetty: Upgrade to Jetty 6.1.26, Tomcat 6.0.35, and JSTL 1.2.
    - Supports Servlet 2.5 / JSP 2.1 standards
    - Jetty and Tomcat jars are checked in, no more need to
      download Jetty in the build process.
    - Bundle Jetty 6 rewrite handler and JMX
    - Bundle sample Jetty config files for rewrite, JMX, and SSL
    - Use ant's ant.jar instead of the one from Jetty
    - Port router console, i2psnark, and I2PRequestLog code to Jetty 6
    - Remove all old Jetty 5 patches and the custom Server() constructor,
      this will break Seedless use of the custom constructor
    - Fix up all .jsps to JSP 2.1 standards
    - Include automatic migration of clients.config,
      and of jetty.xml files for an eepsite at port 7658.
      New config includes files in eepsite/contexts and eepsite/etc
      Any other Jetty-hosted eepsites,
      or an eepsite not at port 7658 or with custom
      modifications of the jetty.xml file, will require
      manual editing of the new Jetty config files.
      This includes modifications for the seedless server in jetty.xml.
    - The following plugins are not compatible with Jetty 6
      and will be disabled until updates are available:
         i2pcontrol, pebble, and zzzot
    - Users updating must use the updaterWithJetty build target once,
      to get the new Jetty and Tomcat.
    - Put I2PRequestLog in its own jetty-i2p.jar
    - Jetty logging moved from wrapper to I2P log using the new I2PLogger class,
      also in jetty-i2p.jar
  * Console: Start all wars after the main console war,
    for faster startup and to prevent one failed war from preventing
    startup of the entire console
  * i2psnark: Disable i2psnark RunStandalone, unused and instantiated Jetty 5
  * i2ptunnel: Move i2ptunnel Bean classes from the jar to the war.
    These were deprecated for external use long ago.
    This will break very old seedless plugins; updates have
    been available for months.
  * susimail: Copy MultiPartRequest and other required classes from Jetty 5.1.15
    and add it to susimail, as the replacement MultiPartFilter in
    Jetty 6 is difficult to migrate to, and does not support content-type

2012-03-03 zzz
  * Console:
    - New simplified home page, refreshing with AJAX
    - New home configuration page
  * i2psnark:
    - CSS tweaks
    - Ajax and link fixes
    - Move js to console in prep for merging w/ homepage
  * NetDB: Remove bw stats (effective next release)

2012-03-02 zzz
  * BlockfileNamingService: Add negative cache
  * Build: Add built-by to jars; check for corrupt jars on debug page
  * configstats.jsp: Hide log settings unless already enabled
  * DataStructures:
    - Remove static logs
    - Sort addresses in RouterInfo at initialization only;
      change from Set to List to save space
    - Remove unused counters in Lease to save space
    - Increase max leases to 16
  * Graphs:
    - New single graph page with easy resizing
    - Support graphing of previous intervals
  * i2pinstall.exe: Add icon
  * i2psnark:
    - Add tracker configuration form
    - Remove custom tracker option from create form
    - Add private torrent option
    - More icons in buttons
    - Use js for refresh
  * I2PTunnelHTTPClient:
    - Refactoring to use Java URI parser to better handle
      escapes, IPv6 addresses, ports
    - Rewrite i2paddresshelper scanning/removal
    - Refactor out local server code
    - Nicer address helper error page
  * NetDB:
    - Reenable verify of RI stores, disabled in 0.7.9,
      checkin comments claim reenabled in 0.7.10 but didn't happen.
    - Synchronize StoreJob.sendNext() to avoid dups
  * netdb.jsp: Fix debug leaseset count again
  * susidns: Add b64 hash to details page

* 2012-02-27 0.8.13 released

2012-02-22 kytv
  * Updated German, Italian, Spanish, Swedish, and Ukrainian translations
    from Transifex.

2012-02-22 zzz
  * ExploratoryPeerSelector: Use fast peers if hidden for
    inbound tunnels to improve success
  * NetDB:
    - Don't publish our RI if it has no addresses
    - Publish our RI sooner after startup
      to facilitate our IB tunnel builds

2012-02-20 zzz
  * i2ptunnel:
    - Fix streamr session registration
    - Don't delete privkey file for a non-persistent client tunnel
      (ticket #599)
  * Streaming: Fix race NPE (thx echelon)

2012-02-17 zzz
  * i2psnark: Escape fixes
  * netdb.jsp: Fix debug median calculation

20112-02-17 kytv
  * Add Czech language from Transifex (thanks Waseihou)

2012-02-12 str4d
  * i2ptunnel: Tunnel creation wizard

2012-02-10 zzz
  * WorkingDir: Fix detection of migrated directory

2012-02-09 zzz
  * i2psnark: Escape semicolons

2012-02-04 zzz
  * Deprecate util classes used only by installer
  * ProfileOrganizer: Add profileOrganizer.sameCountryBonus config
  * WorkingDir: Reset dates of eepsite files while migrating
                to avoid exposing install time (thx Z6)
  * Wrapper files:
    - Move PID and status files to config dir in i2prouter
    - Don't set PID files in wrapper.config as Windows doesn't need them
      and the wrapper won't start if the dir doesn't exist
    - Move wrapper.log to config dir using override in i2prouter,
      Windows stays in system temp dir
    - Move wrapper.log to config dir for no wrapper
    - Move wrapper.log setup for no wrapper from RouterLaunch
      to WorkingDir
    - Redirect stderr too when no wrapper
    - Create config dir in i2prouter for Linux/Mac

2012-02-02 kytv
 * Ukrainian and Polish translation updates from Transifex

2012-01-30 zzz
  * i2psnark: More illegal chars
  * LogWriter: Don't rotate and open file until first message
  * SusiDNS: Reduce listings to 50/page

2012-01-27 zzz
  * Build: Repack release jars with pack200 -r, saves about 1% and
           might save a little memory at runtime too
  * confignet: Add UDP disable option
  * SAM: Remove client demo classes from sam.jar

2012-01-26 zzz
  * configclients: Fix form action default
  * NetDB: Increase min ff to 200
  * Plugins: Fix updated count
  * SusiDNS: Make UI 1-based

2012-01-24 zzz
  * Addresses: Fix NPE if no interfaces found http://forum.i2p/viewtopic.php?t=6365
  * i2ptunnel: Fix white-on-white buttons on hover
  * Plugins: Add completion message after all-update check
  * susidns, susimail: Add icons to buttons

2012-01-22 zzz
  * Transports: Bind only to a single interface if specified
                as the host address and it's available (ticket #591)
  * VMCommSystem: Move to dummy directory

2012-01-21 zzz
  * Build: Fix Windows build, version checking for release
  * Console summary bar: Move some code around

2012-01-20 sponge
  * Fix too short of delay for http. It is up to the browser to time out
    in a shorter time, not the proxy. This is wreaking havoc on large
    downloads, similar to the issues that we had in the distant past with
    jetty's default timeout being too short.

2012-01-18 zzz
  * I2PTunnel: Register ports with the PortMapper
  * Router:
    - Use new synchronized change-and-save-config methods
      to eliminate races with ReadConfigJob
  * Tunnels:
    - When a peer is shitlisted, fail all our tunnels where
      that peer is the adjacent hop. In particular this
      will remove outbound tunnels when we can't contact
      the first hop, and enable quicker recovery.
  * Update: Find the proxy port in the PortMapper

2012-01-16 hottuna
  * Router:
    - Don't throttle tunnel creation if using a higher
    - than default router.maxParticipatingTunnels setting.

2012-01-16 zzz
  * Build: Put Implementation-Version in manifests
  * NetDB: Hopefully fix rare NPE (ticket #589)
  * Plugins:
    - Only stop a plugin before update if it was running
    - Only stop a plugin at shutdown if it was running
    - Don't start a plugin after update if it was disabled
    - Disable plugin if it fails version checks at startup
    - Auto-update plugins after a router update
    - Add update-all button and more cancel buttons
  * Router:
    - Add synchronized change-and-save-config methods to avoid races
    - Save previous version in config so we know when we updated
  * Transport: Revert change from -2, put addresses back in RouterInfo
               when hidden, broke inbound tunnel building

2012-01-14 zzz
  * i2ptunnel: Partial fix for dest formatting (ticket #581)
  * jars.jsp: New debug page
  * logs.jsp: Use wrapper method to find wrapper log if available
  * Stats:
    - Cleanups
    - Remove some locking
    - Change some longs to ints to save space
    - Remove static logs

2012-01-13 zzz
  * i2prouter: Add translation infrastructure

2012-01-10 zzz
  * Console:
    - Add info to error 500 page
    - Add indication on summary bar when in VM comm system
    - Make graceful the default for HUP (ticket #580)
    - Fix class error on wrapper 3.1.1
  * i2prouter: Don't attempt to translate strings from script
  * Router:
    - Auto-hidden mode for bad countries
    - Don't put addresses in our RouterInfo when hidden

2012-01-08 zzz
  * Plugins:
    - Enforce min and max Jetty versions at plugin installation
    - Enforce I2P, Java, and Jetty versions at plugin startup too
  * Router:
    - No longer check for updates or start any threads in the Router constructor,
    - for ease in building multiple routers in the JVM,
    - and also because starting threads in a constructor is bad practice.
    - All threads now start in runRouter().
    - Installation of updates now only happens via Router.main().
  * RouterInfo, RouterAddress: Optimizations and integrity checks
    - Remove synchronization
    - Do not allow contents to change after being set, throw IllegalStateException
    - Do not copy contents out in getters
    - Make options final
    - Add getOption() and getOptionsMap() methods
  * Router shutdown:
    - Fix failsafe shutdown hook broken in 0.8.8;
      HUP, INT, and TERM signals should now shut down cleanly.
    - Shutdown hook no longer prevents other hooks from running
    - Trap HUP, if router.gracefulHUP=true, and do graceful shutdown.
      Only under wrapper, non-Windows.
    - i2prouter stop now uses SIGTERM
    - Implement i2prouter graceful using SIGHUP (ticket #580)
    - Configure wrapper to ignore SIGUSR1 and SIGUSR2 as they will shut down
      or crash the JVM

2012-01-06 kytv
  * EepGet: If transfer fails, exit with status 1 (fixes #576)

* 2012-01-06 0.8.12 released

2012-01-04 kytv
  * Update geoip.txt based on Maxmind GeoLite Country database from 2011-12-08

2012-01-02 kytv
  * Wrapper 3.5.13 for everything other than armv7.

2012-01-02 zzz
  * Fix webapp PortMapper lookup for SSL-only console
  * Wrapper 3.5.13 for arm v7

2011-12-31 zzz
  * Fix log NPE when saveConfig() fails at startup, thx kytv
   (backport from jetty6 branch)

2011-12-30 zzz
  * New Estonian translation thanks ajutine

2011-12-27 kytv
  * Spanish and Swedish translation updates from Transifex

2011-12-23 zzz
  * Logging: Eliminate LogWriter/LogManager deadlock

2011-12-18 zzz
  * Addresses: Add utility toString() methods
  * Blocklist: Buffer input to speed lookup
  * PersistentDataStore: Buffer file writes and reads
  * Router: Cleanup startup jobs and router.config reading; javadocs
  * Transport: Log tweaks

2011-12-17 kytv
  * Ukrainian translation updates from Transifex
  * Add my key to TrustedUpdate.java

2011-12-17 zzz
  * i2psnark:
    - Replace file name characters not supported in default charset
    - Add torrent file name to local details page
  * GeoIP: Reduce thread priority during lookup
  * ProfileManager: Make some methods non-blocking to reduce
                    lock contention in transports

2011-12-15 kytv
  * Swedish translation updates from Transifex

2011-12-14 zzz
  * BuildHandler: Increase next hop timeout again
  * DataHelper:
    - Speed up heavily used long/byte[] converters
    - Add little endian versions of the converters
    - Cache common properties keys
  * GarlicMessageParser: Use cached cert
  * GeoIP: Buffer input to speed lookup by 10x
  * I2NP: Disable pass-through checksum debugging
  * MessageHistory:
    - Flush at shutdown
    - Fix file location, only delete if enabled
    - Cleanups, concurrent
  * ResettableGZIPInputStream: Better footer log errors
  * RouterAddress: Cache transport names
  * TransportBid: Remove unused stuff

2011-12-13 kytv
  * Don't require that full stats are enabled to be able to graph
    router.highCapacityPeers. (closes #450)

2011-12-12 kytv
  * German and Spanish translation updates from Transifex

2011-12-12 zzz
  * ExploreJob: Tweaks to handle DatabaseLookupMessage changes
  * I2NP:
    - Deprecate unused stream methods and I2NPMessageReader since
      all transports provide encapsulation.
    - Don't throw IOE from byte array methods
    - Use cached null cert in GarlicClove
    - Add method to limit size of buffer to read
    - Don't check checksum at input, in most cases
    - Reuse checksum at output, for unmodified pass-through messages
      (but recalculating it now and logging on a mismatch for testing)
    - Fix DatabaseLookupMessage to internally store the don't include peers as
      a List, not a Set, so it doesn't get reordered and break the checksum
    - Log cleanup
  * NTCP:
    - Zero-copy and limit size when handing buffer to I2NP
    - Log hex dump message on I2NPMessageException, like in SSU
    - Don't close connection on I2NPMessageException
  * PortMapper: New service for registering application ports in the context
  * ReusableGZIPInputStream: Fix 3 major bugs, all present since 2005:
    - Payloads an exact multiple of 512 bytes failed to decompress
    - Data at the end of the stream could be lost
    - read() returned -1 when the data was 0xff
  * SearchState: generics and cleanups

2011-12-11 sponge
  * HTTP server tunnel, use log.WARN for 3 first minutes. (closes #460)

2011-12-10 kytv
  * Replace eepget's whitelist of accepted characters with the
    blacklist from i2psnark. (closes #562)

2011-12-09 zzz
  * Base64: Add decodestring command in main()
  * Console, i2psnark: More button CSS tweaks
  * I2NP:
    - Earlier detection and better logging of
      truncated TunnelGatewayMessage and DatabaseStoreMessage
    - Fix and enhance UnknownI2NPMessage implementation
    - Don't deserialize or verify the checksum of the
      embeddedI2NP message in the TunnelGatewayMessage
      at the IBGW, just use UnknownI2NPMessage and pass it along,
      except if zero hop; Still to do: similar thing at OBEP
    - Cleanups and javadoc
  * LeaseSet: Fix size calculations
  * UDP:
    - Fix major bug from 2005 that corrupted outbound messages
      that were an exact multiple of the fragment size.
    - Round expiration times when converting to seconds
    - Zero-copy of single-fragment messages in MessageReceiver
    - Optimizations, log tweaks, comments

2011-12-06 zzz
  * Router:
    - More refactoring tasks to their own files
    - Adjust some thread priorities
  * Susimail: Adjust login form sizes
  * Tunnels: Increase next hop send timeout
  * UDP: Fix major MTU bug introduced in 0.8.9.
    - Change large MTU from 1492 to 1484 and small from 608 to 620
      for encryption padding efficiency
    - Enforce sent MTU limit
    - Increase receive buffer size from 1536 to 1572 so that excessive-sized
      packets sent by 0.8.9-0.8.11 routers aren't dropped
    - Limit the max acks in a data packet
    - Limit the duplicate acks in successive data packets
    - Only include acks that will fit in the mtu in a data packet
    - Correctly remove acks from the pending set after they are sent,
      so they aren't sent repeatedly
    - Don't pad data packets unless necessary
    - Debug logging and javadocs

2011-12-04 zzz
  * Console:
    - Less icons on configclients.jsp
    - Fix some browsers breaking line on negative numbers
    - Tab CSS tweaks
  * i2psnark: Fix directories not always deleted when torrent is deleted
  * IRC Client: Lower log level for connect error to warn (thx echelon/sponge)
  * Tunnel RED:
    - Complete rework of participating traffic RED.
      Implement an accurate bandwidth tracker in FIFOBandwidthRefiller.
    - Fix drop priority of VTBM at OBEP
    - Lower drop priority of VTBRM at IBGW
    - Raise threshold from 95% to 120%
    - Remove unused things in HopConfig
  * UDP: Fix i2np.udp.allowLocal operation (thx Quizzers)

2011-12-02 zzz
  * Console:
    - Summary bar tweaks
    - Config nav CSS tabs
    - CSS cleanups from last checkin
  * Susimail:
    - Login screen tweaks
    - Cleanups, generics, static

2011-12-01 zzz
  * Console:
    - Split up config network page
    - CSS tweaks in summary bar
    - Spiff up the buttons
  * i2psnark:
    - Retry link on torrent download fail
    - Clear URL after clicking 'add torrent'
    - Message tweaks
    - CSS tweaks
  * IRC Server: Fix IOOBE (ticket #559)
  * Throttle: Update throttle status immediately on shutdown request;
              clear starting-up message after 20 minutes

2011-11-29 zzz
  * Random: Use new nextBytes(buf, off, len) for efficiency
  * Router: Refactor periodic tasks to their own files

2011-11-28 zzz
  * Specify locale in all toLowerCase() and toUpperCase() calls to
    avoid the "Turkish four i problem";
    replace most equalsIgnoreCase() calls too.
  * Update: Files listed in deletelist.txt will be deleted

2011-11-28 kytv
  * IRCClient: Add IRCop commands (and other safe commands) to the whitelist

2011-11-27 zzz
  * IRCClient: Outbound whitelist optimization
  * Reseed:
    - Restore i2pbote (ticket #516)
    - Remove r31453 (cert expiring, host soon to be shut down permanently)

2011-11-26 zzz
  * DCCServer: Socket error log fix
  * NTCP: Fix pumper NPE (ticket #555)

2011-11-23 zzz
  * CryptixAESEngine: Fix bogus bounds checks
  * NTCP:
    - More optimizations in recvEncrypted()
    - More efficient XOR
    - Reduce bandwidth stat update frequency
    - Check for repeated zero-length reads
  * RandomSource: Add new method getBytes(buf, offset, length)
  * Tunnel encryption: More efficient XOR

2011-11-21 zzz
  * NTCP Pumper:
    - Ensure failsafe pumper code gets run on schedule
    - Don't copy the read buffers
    - Adjust minimum read buffers based on memory
    - New i2np.ntcp.useDirectBuffer option (default false)
    - Mark peer unreachable when read failure is during establishment
    - Change some Reader Lists to Sets to avoid linear search
    - Log tweaks, debugging, new loop stats

2011-11-18 zzz
  * NTCP:
    - First cut at improving EventPumper performance (ticket #551)
    - Establishment timeout cleanup/concurrent
    - Remove some logging and stats
    - Switch some Queues from LBQ to CLQ
    - Static ByteBuffer cache

2011-11-16 zzz
  * Console: Add Jetty version to logs page
  * NTCP: Reduce log level for race (ticket #392)
  * NTCPConnection: Concurrent PrepBufs
  * OutNetMessage: Remove some fields and methods used only in NTCP debugging
  * Router: Move router.ping file from temp directory to config directory

2011-11-14 zzz
  * Console: Remove % chart at bottom of tunnels.jsp
  * Profiles: Only use same-country metric for countries with
    lots of I2P users
  * SusiDNS: Remove .jsp suffixes

2011-11-12 zzz
  * Installer: Fix Ukrainian translation (ticket #550) thx rndnick

2011-11-11 zzz
  * Console:
    - Less magic and fix img sizes, for speed and less artifacts while rendering
    - CSS tweaks

2011-11-09 zzz
  * Console: Add ability to hide news
  * I2PTunnel IRC Client: Don't filter PASS (ticket #549)
  * Licenses: Update information
  * Router: Clean up config map methods and uses
  * wrapper.config: Increase shutdown timeout

* 2011-11-08 0.8.11 released

2011-11-05 kytv
  * Update geoip.txt based on Maxmind GeoLite Country
    database from 2011-11-02

2011-11-02 zzz
  * HTTP Proxy: Error page tweak
  * Reseed:
    - Add new host
    - Handle % escaping in file URLs
    - Do basic validation of router hash
    - Add some more sanity checks

2011-11-01 kytv
  * Update Ukrainian translations from Transifex
  * Update i2prouter script for better compatibility with Gentoo

2011-10-31 zzz
  * NetDB: Reduce max RI publish interval
  * ProfileOrganizer:
    - Fix expiration of old profiles
    - Don't exceed high cap limit between reorgs
    - Reduce max reorg cycle time
    - Reduce new bonus values
    - Fix rare NSEE thx sponge
  * SSU: Increase threshold for incremented cost
  * Tunnels:
    - Restore and implement lengthOverride()
    - Adjust quantity override

2011-10-29 zzz
  * BuildHandler: Add router.buildHandlerThreads config setting
  * CapacityCalculator: Small adjustment for XOR distance to
    break ties and encourage closeness
  * ProfileOrganizer: Reduce min expire time
  * SSU: Limit max peers to use as introducers

2011-10-28 zzz
  * BuildHandler: Move inbound request handling to its own thread(s)
    (ticket #542, see also http://zzz.i2p/topics/996)
  * CapacityCalculator: Small boost for connected peers, new peers, and
    same-country peers; deduct for recently-unreachable peers
  * DecayingBloomFilter: Whups fix NPE from previous checkin if log=INFO
  * NTCP: Reduce min idle time
  * SSU:
    - Increase default max connections again
    - Reduce min idle time
    - Separate out introducer pinger from introducer selection
      so it can be run separately and more often
    - Only ping introducers if we need them
  * Tunnels:
     - Reduce exploratory tunnel quantity if build success rate
       is very low, but may disable this later
     - Try rebuilding same tunnel (some of the time)

2011-10-25 zzz
  * BloomSHA1, DecayingBloomFilter:
    - Refactor for concurrent, at some small risk of false negatives
    - Optimizations to cache objects and reuse offsets
  * Tunnels:
    - Make most classes package private
    - Final, static, logs, cleanups
    - Consolideate createRateStat calls
    - Add getTotalLength()
    - Remove unused lengthOverride()
  * UDP: Mark only first fragment as a duplicate

* 2011-10-20 0.8.10 released

2011-10-19 kytv
  * Update Italian translation from Transifex (thanks danimoth)

2011-10-19 zzz
  * I2PTunnel: Fix timeout message on POST (ticket #531)
  * NetDB: Reduce RI max expiration again

2011-10-18 zzz
  * StoreJob: Ensure nonzero token
  * Tunnels: Connection limit mitigation:
    - Disable tunnel testing
    - Implement closest-to-the-key tunnel selection
    - Use closest-selection in NetDB lookups, stores, and verifies;
      OCMOSJ; and in BuildRequestor

2011-10-17 zzz
  * BuildExecutor: Efficiency tweak
  * Console: Hide tunnel lag if tunnel testing is disabled
  * NetDB: Fix rare NPE from netdb.jsp (ticket #539)
  * Router: Change all shutdown CRITs to ERRORs; shutdown
    the stat manager last to reduce chance of NPEs
    (similar to that in tickets #534,535)
  * SSU: Increase max concurrent outbound attempts;
    fix udp.establishRejected stat

2011-10-15 zzz
  * BuildExecutor: Add tunnel.buildConfigTime stat
  * configupdate.jsp:
    - Fix setting to 'never' (ticket #523)
    - Fix always saying trusted keys changed
    - Parameterize tags
  * EepGet:
    - Add gunzip support (nonproxied only)
    - Clean up progress formatting
  * FloodfillMonitorJob: Log tweak (ticket #533)
  * I2CP: Improve error message (ticket #533)
  * JobQueue:
    - Log error when queue is out of order
    - Log tweaks
  * FloodfillPeerSelector: Fix stat NPE (tickets #534,535)
  * RouterThrottle:
    - Fix stat NPE (tickets #534,535)
    - Increase max tunnels and max delay again
  * OutNetMessagePool: Log tweak (ticket #533)
  * Router:
    - Add OOM help (ticket #533)
    - Prevent parallel shutdowns after multiple OOMs (tickets #534,535)
  * Stats: Add API methods for zero duration
  * SSLEepGet:
    - Add gunzip support
    - Increase buffer size
  * SSU: Fix concurrency errors (ticket #536)          \

2011-10-13 kytv
  * Updated translations from Transifex
    - Swedish: debconf and i2psnark
    - Finnish: router console

* 2011-10-11 0.8.9 released

2011-10-10 zzz
  * Lower max netdb RI expiration again
  * Increase default max tunnels
  * Cleanups after review
  * Exorcism (ticket #476)

2011-10-07 kytv
  * GeoIP:
    - Switch to Maxmind's GeoIP service (it's better maintained
      than our old provider)
    - Update based on Maxmind GeoLite Country database from 2011-10-07
  * Translation updates from Transifex:
    - I2PSnark: de, es, and pt
    - I2PTunnel: de and es
    - RouterConsole: de and es
    - SusiDNS: de and es
    - SusiMail: de and es

2011-10-07 zzz
  * Reseed:
    - Add an https reseed, thx h2ik
    - Restore ovh reseeds, thx mathiasdm
  * Tunnels:
    - For expl. tunnels, fall back to high cap sooner
    - Tweak build rejections for class N

2011-10-06 kytv
  * Add diftracker.i2p to I2PSnark

2011-10-06 zzz
  * RepublishLeaseSetJob:
    - Out-of-order JobQueue 3nd try to fix
    - Lower timeouts
  * Reseed:
    - Update host lists
    - Switch back to https by default
  * Throttle: Increase max message delay
  * Transport:
    - Add per-style send processing time stat
    - Increase default SSU conn limit

2011-10-05 zzz
  * Streaming: Fix build
  * UDP: Catch address without key sooner

2011-09-30 zzz
  * logs.jsp: Add wrapper version
  * Shitlist: Shorten time
  * Wrapper: Update armv7 to 3.5.12

2011-09-30 kytv
  * fix umask bug by upgrading to wrapper v3.5.12. Binaries are from Tanuki's
    delta pack for the community edition, except:
    - Win64: not available from Tanuki--compiled with VS2010
    - FreeBSD: Tanuki's binaries are compiled in FBSD v6.  I compiled the
      wrapper in FreeBSD 7.4 to eliminate the dependency on the compat6x port.
    - Linux ARM: not available from Tanuki
    - OSX: Tanuki offers separate binaries for 32bit VS 64bit. Our
      wrapper is quad-fat supporting PPC32/PPC64 and x86/x86_64.

2011-09-29 zzz
  * Bandwidth refiller: Reinitialize at restart, avoid
    issues from clock skews

2011-09-27 kytv
  * Remove exotrack.i2p from i2psnark

2011-09-24 zzz
  * HTTPClient: Fix error page not appearing, broken by
                StreamForwarder change
  * HTTPServer: More mime types not to compress

2011-09-23 kytv
  * Update Italian, Spanish, and Swedish translations
    from Transifex

2011-09-20 zzz
  * Crypto: Comment out some main()
  * ClientMessage: Remove unused MessageReceptionInfo
  * i2psnark: File allocation cleanup to use less heap
  * i2ptunnel HTTPResponseOutputStream:
    - Use reusable gunzipper and a larger pipe for efficiency
    - Close output stream in StreamForwarder to prevent lost data,
      existing bug but made worse by larger pipe
  * I2PTunnelHTTPServer: Don't compress small responses or images
  * I2PTunnel, NTCP: Catch unchecked exceptions from GNU NIO (ticket # 519)
  * JobQueue, RepublishLeaseSetJob, StartExplorerJob:
    Out-of-order JobQueue 2nd try to fix
  * NetDB: Limit max explore queue
  * RouterContext: Remove unused MessageStateMonitor

2011-09-18 kytv
 * Add OpenBSD & NetBSD to NBI and CPUID

2011-09-16 zzz
  * Console: Home page flag spacing
  * EepGet: Add some new command line options
  * JobQueue:
    - Add warning to setStartAfter() as queue is no longer
      continuously sorted
    - Fix StartExplorerJob not calling requeue()
    - More pumper cleanups
  * Reseed:
    - Add HTTP proxy authorization support
    - Stub out SSL proxy support
    - Disable i2pbote reseed
  * Router: Fix router changing client-side tunnel options,
    causing original tunnel quantity to not be restored
    (ticket #513)

2011-09-14 zzz
  * Console: Verify valid host/IP before saving on net config form
  * i2psnark:
    - Add refresh time option
    - Add public file permissions option (ticket #501)
    - Fix configuration of tunnel parameters (ticket #524)
    - Allow changing I2CP parameters while tunnel is open
    - Remove duplicated options in I2CP options string
    - Don't open tunnel when saving config
  * IRC DCC: Fix conn limit options
  * Router: Set permissions on router.ping file

2011-09-13 kytv
  * Update i2prouter script

2011-09-12 zzz
  * build.xml: Run test scripts at release time
  * Build Executor:
    - Limit max parallel builds on really slow machines (ticket #519)
    - Slow down build loop when network is apparently disconnected (ticket #519)
  * i2psnark: Fix inaccuracy in the completed bytes display
  * NetDB: Disable floodfill at shutdown time if enabled

2011-09-09 zzz
  * TunnelDispatcher: Fix bug in -13 preventing participating
    tunnels from being expired and causing high CPU usage

2011-09-08 zzz
  * Blocklist: Include IP in shitlist reason
  * Ministreaming: Drop old classes replaced by streaming
    years ago.
  * NTCP: Hopefully fix race NPE, thx devzero
  * Tunnels: Limit Bloom filter size based on max memory

2011-09-07 zzz
  * Console: Limit max displayed participating tunnels
  * JobQueue: Change queue from a Set to a TreeSet for more efficiency
  * TunnelDispatcher: Change participant expire List to a Queue for
    efficiency and to remove global lock. Also remove separate
    time List for space savings.

2011-09-06 zzz
  * Console: Move jobs.jsp rendering code from
    the router to the console
  * Crypto: Rework use of SHA256 for efficiency and
    to avoid clogging the Hash cache with one-time hashes,
    and avoiding the global cache lock.
    This also greatly increases Hash cache hit rates.
    Also use SimpleByteCache for temporary byte buffers.
  * I2PTunnel: Save keys to privkey file when enabling
    persistent key after tunnel creation (ticket #480)
  * JobQueue: Change queue from a List to a Set for efficiency
  * PrivateKeyFile: Add more constructors
  * SDSCache: Use weak refs; increase size for pub keys

2011-09-04 zzz
  * NetDB:
    - Try again to fix ISJ deadlock, thx devzero
    - Lower RI expiration again
    - Expire RIs with SSU only and no introducers sooner
  * Transport: Remove one global lock in OutboundMessageRegistry.

2011-09-03 zzz
  * i2psnark: Fix "eject" button in certain browsers (ticket #511)
  * UDP Inbound:
    - Hopefully fix race NPE, thx devzero
    - Catch some more fragment errors
    - Exception and log tweaks
    - Cleanups and javadocs

2011-09-02 zzz
  * Console: Cache user-agent processing
  * NetDB: Hopefully fix ISJ deadlock, thx devzero

2011-09-02 sponge
  * I2PSnark: Fix GUI html tag for adding a torrent, it was missing a space.

2011-09-01 zzz
  * Console: Enable color logs
  * GeoIP: Cache country codes
  * NetDB: Explore more aggressively if hidden or K
  * UDP: Cleanups and introduction fixes

2011-08-31 zzz
  * OCMOSJ: Remove some global cache locks, other cleanups

2011-08-30 zzz
  * I2CP: Cache b32 lookups client-side
  * I2PTunnelHTTPClient: Use existing session for b32 lookups
                         rather than a new SimpleSession
  * Naming: Increase b32 lookup timeout to 15 sec.

2011-08-29 zzz
  * NetDB:
    - Replace the old parallel lookup method with a true
      Kademlia lookup that iteratively queries additional floodfill
      peers returned in DatabaseSearchReplyMessages. This is a more
      efficient and reliable lookup that will work much better
      when not all floodfill peers are known, and it removes a serious
      limitation to network growth.
    - Limit max number of DSRM entries to look up
    - Cleanups, javadocs, log tweaks
  * Tunnels:
    - Increase timeouts on all deferred netdb lookups to 15s; add lookup stats
    - Cleanups, javadocs, log tweaks

2011-08-28 zzz
  * checkcerts.sh: New test
  * Console: Remove 'firewalled and fast' message, just say 'firewalled'
  * I2PTunnelRunner: Fix logging
  * Log: Fix level stuck at DEBUG when using public constructor
  * OutboundMessageRegistry: Cleanups
  * Stats: Restore pre-0.8.8 API to not create a new Rate if it does not
           exist in RateStat.getRate()
  * UPnP: Lower some log levels

2011-08-26 kytv
  * Debian: Bugfix: Avoid overwriting preseeded debconf values
    upon package installation (ticket #514).
  * Windows: Fix bug in fixperms.bat that occurred when installing on
    non-English versions of Windows 7 and Vista.

2011-08-25 zzz
  * Blockfile:
    - Avoid NPE after corruption (ticket #515)
    - Add reverse lookup table; bump DB rev to 2
  * I2PTunnelIRCClient:
    - Big refactoring into multiple class files
    - Allow AWAY and CAP messages
    - First cut at DCC support - not for SOCKS (yet)
  * Streaming:
    - Hook I2CP ports through to I2PSocket
    - Javadocs, init cleanups, final
  * UDP:
    - Complete rewrite of OutboundMessageFragments for
      concurrent and for efficiency to avoid O(n**2) behavior
    - Don't delay in OutboundMessageFragments at the end
      of the loop if we have more to send now, this should
      speed things up
    - Queue a new send immediately after a packet is acked
    - Send session destroy message when dropping connection
    - Increase large MTU to 1492 (was 1350)
    - Cleanups, log tweaks, javadocs, final

* 2011-08-23 0.8.8 released

2011-08-23 zzz
  * Tweaks after review

2011-08-21 zzz
  * RateStat: Cleanups and javadoc fixes
  * susimail: Fix page encoding

2011-08-20 zzz
  * Translations:
    - New Danish and Ukranian translations from transifex
    - Update Italian, Chinese, Spanish, Polish, Swedish,
      and Vietnamese translations from transifex
    - Update .tx/config

2011-08-19 zzz
  * Soft restart:
    - Allow NTP to reinitialize clock after the comm system
      in the first minute of uptime
    - Fix i2ptunnels not restarting
    - Increase minimum forward clock shift for soft restart
    - Reduce minimum backward clock shift for soft restart
    - Signal the I2CP client with a different message when restarting
    - I2CP client reconnects when receiving restart message

2011-08-17 kytv
  * Fix #506: Don't attempt to load systray4j when using a 64bit JVM
    in Windows.

2011-08-16 zzz
  * Console: Tweak logs page CSS
  * Graphs: Delete corrupt rrd file (ticket #483)
  * UPnP: Fix bug causing failure when the PC has multiple interfaces

2011-08-06 kytv
 * Fix #473 (wrapper.logfile set to the wrong path in Windows).

2011-07-31 zzz
  * Crypto: Implement and then comment out an alternate
            AES-256/CBC implementation using the JVM crypto libs,
            and tests, it isn't faster
  * Netdb: Add a job to refresh all the old router infos at startup,
           to speed integration

2011-07-30 kytv
 * Installer:
   - add libjbigi*core*jnilib, libjbigi-osx-none_64.jnilib, and
     libjbigi-linux-ppc.so
   - Add Linux PPC wrapper
 * Add linux-ppc to NBI.
 * Remove unused lock

2011-07-29 zzz
  * Netdb Search:
    - Follow all DSRM's, not just the last one, by moving the code
      from the match job to the selector
    - Update peer profile after SingleSearchJob
    - Cleanups, javadocs, log tweaks, final
  * ProfileOrganizer: Tweak fast tier size

2011-07-28 zzz


----------------

EARLIER HISTORY IS AVAILABLE IN THE SOURCE PACKAGE
